#ifndef _LBBCSAMPLECONFIGFILE_H
#define _LBBCSAMPLECONFIGFILE_H

#include <BBC.h>

namespace LBBC {

class _BBCExport SampleConfigFile : public Ogre::ConfigFile {
  public:
    SampleConfigFile();
	
    virtual ~SampleConfigFile();

	Ogre::String getEntitySampleMaterialName();

	bool getEntityDistributionMerged();

	Ogre::String getEntityDistributionSplittedMeshName();

	Ogre::String getEntityDistributionSplittedMaterialName();

	Ogre::String getEntityDistributionMergedMeshName();

	Ogre::String getEntityDistributionMergedMaterialName();

	bool getEntityDistributionSplitted();

	Ogre::String getEntitySampleMeshName();

	bool getEntityDistributionGeneration();

	Ogre::String getEntityDistributionFolder();

	Ogre::String getEntityDistributionXMLName();

	Ogre::String getEntitiesFolder();

	bool getEntitySampleMeshGeneration();

	Ogre::String getEntitiesMeshName();

	bool getEntityClustersGeneration();

	float getEntityClustersAlpha();

	unsigned int getEntityClustersMaxClusters();

	unsigned int getEntityClustersNumIterations();

	Ogre::String getEntityClustersFolder();

	bool getEntityClustersMergedClusters();

	bool getEntityClustersSplittedClusters();

	Ogre::String getEntityClustersMergedMeshName();

	Ogre::String getEntityClustersSplittedMeshName();

	Ogre::String getEntityClustersMergedMaterialName();

	Ogre::String getEntityClustersSplittedMaterialName();

	bool getBillboardCloudMergedBillboards();

	bool getBillboardCloudSplittedBillboards();

	bool getBillboardCloudGeneration();

	Ogre::String getBillboardCloudFolder();

	Ogre::String getBillboardCloudMergedMeshName();

	Ogre::String getBillboardCloudGroupedMeshName();

	Ogre::String getBillboardCloudSplittedMeshName();

	Ogre::String getBillboardCloudMergedMaterialName();

	Ogre::String getBillboardCloudSplittedMaterialName();

	Ogre::String getBillboardCloudGroupedMaterialName();

	Ogre::String getBillboardCloudSplittedTextureUnit0Name();

	Ogre::String getBillboardCloudMergedTextureUnit0Name();

	Ogre::String getBillboardCloudGroupedTextureUnit0Name();

	Ogre::String getBillboardCloudGroupedXMLName();

	Ogre::String getBillboardCloudSplittedXMLName();

	Ogre::String getBillboardCloudMergedXMLName();

	unsigned int getBillboardCloudGroups();

	bool getBillboardCloudGroupedBillboards();

	bool getBillboardCloudDiffuseColorEntityTextureAtlasGeneration();

	Ogre::String getBillboardCloudDiffuseColorEntityTextureName();

	Ogre::String getBillboardCloudDiffuseColorEntityTextureAtlasName();

	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasBitRange();

	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasSize();

	unsigned int getBillboardCloudDiffuseColorBillboardGroupTextureSize();

	bool getBillboardCloudIndirectBillboardGroupTextureAtlasGeneration();

	Ogre::String getBillboardCloudIndirectBillboardGroupTextureAtlasName();

	unsigned int getBillboardCloudIndirectBillboardGroupTextureAtlasBitRange();

	unsigned int getBillboardCloudIndirectBillboardGroupTextureAtlasSize();

	unsigned int getBillboardCloudIndirectBillboardGroupTextureSize();

	bool getBillboardCloudDiffuseColorBillboardGroupTextureAtlasGeneration();

	bool getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasGeneration();

	Ogre::String getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasName();

	unsigned int getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasBitRange();

	unsigned int getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize();

	unsigned int getBillboardCloudDiffuseColorMergedBillboardsTextureSize();

	unsigned int getBillboardCloudDiffuseColorBillboardGroupTextureAtlasSize();

	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples();

	bool getBillboardCloudIndirectMergedBillboardsTextureAtlasGeneration();

	Ogre::String getBillboardCloudIndirectMergedBillboardsTextureAtlasName();

	unsigned int getBillboardCloudIndirectMergedBillboardsTextureAtlasBitRange();

	unsigned int getBillboardCloudIndirectMergedBillboardsTextureAtlasSize();

	unsigned int getBillboardCloudIndirectMergedBillboardsTextureSize();

};

}

#endif